//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the pcl_ros package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __pcl_ros__SACSEGMENTATIONFROMNORMALSCONFIG_H__
#define __pcl_ros__SACSEGMENTATIONFROMNORMALSCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace pcl_ros
{
  class SACSegmentationFromNormalsConfigStatics;
  
  class SACSegmentationFromNormalsConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(SACSegmentationFromNormalsConfig &config, const SACSegmentationFromNormalsConfig &max, const SACSegmentationFromNormalsConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const SACSegmentationFromNormalsConfig &config1, const SACSegmentationFromNormalsConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, SACSegmentationFromNormalsConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const SACSegmentationFromNormalsConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, SACSegmentationFromNormalsConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const SACSegmentationFromNormalsConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T SACSegmentationFromNormalsConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (SACSegmentationFromNormalsConfig::* field);

      virtual void clamp(SACSegmentationFromNormalsConfig &config, const SACSegmentationFromNormalsConfig &max, const SACSegmentationFromNormalsConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const SACSegmentationFromNormalsConfig &config1, const SACSegmentationFromNormalsConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, SACSegmentationFromNormalsConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const SACSegmentationFromNormalsConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, SACSegmentationFromNormalsConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const SACSegmentationFromNormalsConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 13 "../cfg/SACSegmentationFromNormals.cfg"
      double normal_distance_weight;
//#line 11 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      int max_iterations;
//#line 12 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      double probability;
//#line 13 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      double distance_threshold;
//#line 14 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      bool optimize_coefficients;
//#line 15 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      double radius_min;
//#line 16 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      double radius_max;
//#line 17 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      double eps_angle;
//#line 18 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      int min_inliers;
//#line 19 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      std::string input_frame;
//#line 20 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      std::string output_frame;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("SACSegmentationFromNormalsConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const SACSegmentationFromNormalsConfig &__max__ = __getMax__();
      const SACSegmentationFromNormalsConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const SACSegmentationFromNormalsConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const SACSegmentationFromNormalsConfig &__getDefault__();
    static const SACSegmentationFromNormalsConfig &__getMax__();
    static const SACSegmentationFromNormalsConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const SACSegmentationFromNormalsConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void SACSegmentationFromNormalsConfig::ParamDescription<std::string>::clamp(SACSegmentationFromNormalsConfig &config, const SACSegmentationFromNormalsConfig &max, const SACSegmentationFromNormalsConfig &min) const
  {
    return;
  }

  class SACSegmentationFromNormalsConfigStatics
  {
    friend class SACSegmentationFromNormalsConfig;
    
    SACSegmentationFromNormalsConfigStatics()
    {
//#line 13 "../cfg/SACSegmentationFromNormals.cfg"
      __min__.normal_distance_weight = 0.0;
//#line 13 "../cfg/SACSegmentationFromNormals.cfg"
      __max__.normal_distance_weight = 1.0;
//#line 13 "../cfg/SACSegmentationFromNormals.cfg"
      __default__.normal_distance_weight = 0.1;
//#line 13 "../cfg/SACSegmentationFromNormals.cfg"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<double>("normal_distance_weight", "double", 0, "The relative weight (between 0 and 1) to give to the angular distance (0 to pi/2) between point normals and the plane normal.", "", &SACSegmentationFromNormalsConfig::normal_distance_weight)));
//#line 11 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.max_iterations = 0;
//#line 11 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.max_iterations = 100000;
//#line 11 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.max_iterations = 50;
//#line 11 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<int>("max_iterations", "int", 0, "The maximum number of iterations the algorithm will run for", "", &SACSegmentationFromNormalsConfig::max_iterations)));
//#line 12 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.probability = 0.5;
//#line 12 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.probability = 0.99;
//#line 12 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.probability = 0.99;
//#line 12 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<double>("probability", "double", 0, "The desired probability of choosing at least one sample free from outliers", "", &SACSegmentationFromNormalsConfig::probability)));
//#line 13 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.distance_threshold = 0.0;
//#line 13 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.distance_threshold = 1.0;
//#line 13 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.distance_threshold = 0.02;
//#line 13 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<double>("distance_threshold", "double", 0, "The distance to model threshold", "", &SACSegmentationFromNormalsConfig::distance_threshold)));
//#line 14 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.optimize_coefficients = 0;
//#line 14 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.optimize_coefficients = 1;
//#line 14 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.optimize_coefficients = 1;
//#line 14 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<bool>("optimize_coefficients", "bool", 0, "Model coefficient refinement", "", &SACSegmentationFromNormalsConfig::optimize_coefficients)));
//#line 15 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.radius_min = 0.0;
//#line 15 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.radius_min = 1.0;
//#line 15 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.radius_min = 0.0;
//#line 15 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<double>("radius_min", "double", 0, "The minimum allowed model radius (where applicable)", "", &SACSegmentationFromNormalsConfig::radius_min)));
//#line 16 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.radius_max = 0.0;
//#line 16 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.radius_max = 1.0;
//#line 16 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.radius_max = 0.05;
//#line 16 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<double>("radius_max", "double", 0, "The maximum allowed model radius (where applicable)", "", &SACSegmentationFromNormalsConfig::radius_max)));
//#line 17 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.eps_angle = 0.0;
//#line 17 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.eps_angle = 1.5707;
//#line 17 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.eps_angle = 0.17;
//#line 17 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<double>("eps_angle", "double", 0, "The maximum allowed difference between the model normal and the given axis in radians.", "", &SACSegmentationFromNormalsConfig::eps_angle)));
//#line 18 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.min_inliers = 0;
//#line 18 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.min_inliers = 100000;
//#line 18 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.min_inliers = 0;
//#line 18 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<int>("min_inliers", "int", 0, "The minimum number of inliers a model must have in order to be considered valid.", "", &SACSegmentationFromNormalsConfig::min_inliers)));
//#line 19 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.input_frame = "";
//#line 19 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.input_frame = "";
//#line 19 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.input_frame = "";
//#line 19 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<std::string>("input_frame", "str", 0, "The input TF frame the data should be transformed into, if input.header.frame_id is different.", "", &SACSegmentationFromNormalsConfig::input_frame)));
//#line 20 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __min__.output_frame = "";
//#line 20 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __max__.output_frame = "";
//#line 20 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __default__.output_frame = "";
//#line 20 "/tmp/buildd/ros-electric-perception-pcl-1.0.2/debian/ros-electric-perception-pcl/opt/ros/electric/stacks/perception_pcl/pcl_ros/cfg/SACSegmentation_common.py"
      __param_descriptions__.push_back(SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr(new SACSegmentationFromNormalsConfig::ParamDescription<std::string>("output_frame", "str", 0, "The output TF frame the data should be transformed into, if input.header.frame_id is different.", "", &SACSegmentationFromNormalsConfig::output_frame)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    SACSegmentationFromNormalsConfig __max__;
    SACSegmentationFromNormalsConfig __min__;
    SACSegmentationFromNormalsConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const SACSegmentationFromNormalsConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static SACSegmentationFromNormalsConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &SACSegmentationFromNormalsConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const SACSegmentationFromNormalsConfig &SACSegmentationFromNormalsConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const SACSegmentationFromNormalsConfig &SACSegmentationFromNormalsConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const SACSegmentationFromNormalsConfig &SACSegmentationFromNormalsConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<SACSegmentationFromNormalsConfig::AbstractParamDescriptionConstPtr> &SACSegmentationFromNormalsConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const SACSegmentationFromNormalsConfigStatics *SACSegmentationFromNormalsConfig::__get_statics__()
  {
    const static SACSegmentationFromNormalsConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = SACSegmentationFromNormalsConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __SACSEGMENTATIONFROMNORMALSRECONFIGURATOR_H__
